// Program to generate pseudo-random instances for problem Physical Music,
// instances of the form: 10  10 2 3 4 5 6 7 8 9 1
// which may cause `physicalmusicRudy_TLE2.cc to run out of time.
//
// Author: Rudy van Vliet
// Date: 11 October, 2015

#include <iostream>
#include <cstdlib>
using namespace std;

const int MaxN = 1000000;
int posInDTN[MaxN+1];  // posInDTN[i]: position in Download Top N of single
                       //   ranked i in Single Top N

//****************************************************************************

int GenerateRandomNumber (int Min, int Max)
 // generate a random number between Min en Max (inclusive)
{ int r,
      Range;
  double fr;

  r = rand ();
  Range = Max - Min + 1;
  fr = ((double) r)/(((double) RAND_MAX)+1.0);
    // with just `RAND_MAX + 1' one might exceed MAXINT
    // and thus get a negative number
  fr *= Range;

  return (Min + (int) fr);

}  // GenerateRandomNumber

//****************************************************************************

int main ()
{ int NInst, Inst;
  int N,
      k,    // number of subsequences
      singlesdone, singlesleft,
      subN, // lenfth of subsequence
      r,
      minp, maxp,
      p;

  cin >> NInst;
  cout << NInst << endl;

  for (Inst=1;Inst<=NInst;Inst++)
  { 
    cin >> N >> k;
    cout << N << endl;

    singlesdone = 0;
    singlesleft = N;
    while (k>=1)
    { subN = singlesleft/k;

      if (k>=2)  // randomly adjust subN
      { r = GenerateRandomNumber (90, 110);
        subN = (subN * r) / 100;  // between 90% and 110% of original value
      }

      minp = singlesdone+1;
      maxp = singlesdone+subN;
      if (minp>maxp || maxp>N)
        cout << "Error computing minp/maxp" << endl;
      else
      { if (minp==maxp)
          cout << maxp << endl;
        else
        { cout << maxp << endl;
          for (p=minp+1;p<maxp;p++)
            cout << p << endl;
          cout << minp << endl;
        }

        singlesdone += subN;
        singlesleft -= subN;
        k --;
      }
    }

  }  // for Inst
  
  return 0;

}
