import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;


public class FreightTrainJan {
	
	private static int VERBOSE = 0;
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));
		
		int T = Integer.parseInt(br.readLine());
		
		for (int i = 0; i < T; ++i) {
			String[] firstLine = br.readLine().split(" ");
			String[] secondLine = br.readLine().split(" ");
			
			int N = Integer.parseInt(firstLine[0]);
			int L = Integer.parseInt(firstLine[2]);
			int[] wagons = new int[secondLine.length];
			for (int j = 0; j < secondLine.length; ++j) {
				wagons[j] = Integer.parseInt(secondLine[j]);
			}
			
			bw.write(solve(N,L,wagons) + "\n");
		}
		
		br.close();
		bw.close();
	}
	
	private static int solve(int N, int L, int[] wagons) {
		int imin = 1;
		int imax = N;
		int bestFound = N;
		
		while (imin <= imax) {
			int imid = imin + ((imax - imin) / 2);
			if (VERBOSE >= 1) System.err.println("TRY @ " + imid);
			
			if (fits(imid, N, L, wagons)) {
				imax = imid - 1;
				bestFound = imid;
			} else {
				imin = imid + 1;
			}
		}
		return bestFound;
	}
	
	private static boolean fits(int maxSize, int N, int L, int[] wagons) {
		int used = 1;
		int currStarted = 1;
		
		for (int i = 0; i < wagons.length; ++i) {
			if (VERBOSE >= 2) System.err.print("Wagon #" + wagons[i] + ": ");
			if (currStarted + maxSize - 1 < wagons[i]) {
				// we can not attach this cart to previous locomotive
				
				if (i == 0) {
					used += 1;
					currStarted = wagons[i];
				} else if (currStarted + maxSize + maxSize - 1 < wagons[i]) {
					used += 2;
					currStarted = wagons[i];
					if (VERBOSE >= 2) System.err.println("added two new locs. First of new group");
				} else {
					used += 1;
					currStarted = currStarted + maxSize;
					if (VERBOSE >= 2) System.err.println("added new loc. Group started at " + currStarted);
				}
				
			} else {
				if (VERBOSE >= 2) System.err.println("added to prev. ");
				
			}
		}
		
		if (currStarted + maxSize - 1 < N) {
			used += 1;
			
			if (VERBOSE >= 2) System.err.println("Need one additional loc.");
		}
		
		if (VERBOSE >= 1) System.err.println("Locs: " + used);
		
		return used <= L;
	}
	
}
