// Solution to problem `Physical Music'
// Order: N
//
// Rudy van Vliet, 12 October, 2015

#include<iostream>
#include<cstring>

using namespace std;

const int MaxN = 100000;
int posInDTN[MaxN+1];  // posInDTN[i]: position in Download Top N of single
                       //   ranked i in Single Top N
int posInSTN[MaxN+1];  // posInDTN[p]: position in Single Top N of single
                       //   ranked p in Download Top N
bool physical[MaxN+1]; // physical[p]: is single p in Download Top N
                       //   certainly available as CD single

//*************************************************************************

bool IntegerInRange (const char *variable, int val, int minVal, int maxVal)
{
  if (val>=minVal && val<=maxVal)
    return true;
  else
  { cout << variable << "=" << val << ", but should be in [" << minVal
         << "," << maxVal << "]" << endl;
    return false;
  }

}  // IntegerInRange

//*************************************************************************

int main ()
{ int nInst, inst;
  int N,
      i,        // position in Single Top N
      p,        // position in Download Top N
      notSeen,  // first position in Download Top N we have not seen yet
      nrPhysical;  // number of singles that are certainly available
                   // as CD single
  bool OK,       // input OK
       increase; // should we continue trying to increase notSeen

  cin >> nInst;
  for (inst=1;inst<=nInst;inst++)
  {
    cin >> N;

    for (p=1;p<=N;p++)   // for verifying input
      posInSTN[p] = 0;

    for (i=1;i<=N;i++)
    { cin >> p;

      if (IntegerInRange ("p", p, 1, N))
      {
        posInDTN[i] = p;
        posInSTN[p] = i;
      }
    }

    OK = true;   // verify input
    for (p=1;p<=N;p++)
      OK = OK && IntegerInRange ("posInSTN", posInSTN[p], 1, N);
 
    if (OK)
    {
      notSeen = 1;
      nrPhysical = 0;

      for (i=1;i<=N;i++)
      { p = posInDTN[i];

        if (p==notSeen)
          // p has not overtaken any other single in Single Top N,
          // as compared to Download Top N
        { physical [p] = false;

          // we can increase notSeen by at least 1
          increase = true;
          do
          { if (posInSTN[notSeen]<=i)  // this is certainly true in first
              notSeen ++;                // iteration of this do-loop
            else
              increase = false;
          } while (increase && notSeen<=N);
        }
        else  // p must be larger than notSeen;
              // hence, p has overtaken notSeen in Single Top N,
              // as compared to Download Top N
        { physical[p] = true;
          nrPhysical ++;
        }

      }  // for i

      cout << nrPhysical << endl;
      for (p=1;p<=N;p++)
        if (physical[p])
          cout << p << endl;

    }  // input OK

  }  // for inst

  return 0;

}
