#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <climits>
#include <cassert>

#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>
#include <string>

#include <iostream>
#include <sstream>

#include <utility>
#include <functional>
#include <limits>
#include <numeric>
#include <algorithm> 

using namespace std;
int M, N, a, b, d, mindist;
int oC[123][2], iC[123][2];
int di[123][123];
int oCh[123];

void TrySolution(void) {
	//cerr << "Trying solution\n";
	int dist = 0;
	int i = 0;
	int nr = 0;
	bool first = true;
	while ((i != 0) || (first)) {
		//cerr << "Now in " << i << ", distance so far: " << dist << "\n";
		first = false;
		dist += di[i][oC[i][oCh[i]]];
		i = oC[i][oCh[i]];
		nr++;
	}
	if (nr == N) {
		if (dist < mindist) {
			mindist = dist;
		}
		//cerr << "Total distance: " << dist << '\n';
	} else {
		//cerr << "Not everything visited\n";
	}
}

void UnChangeChoice(int i, int j) {
	oCh[i] = -1;
	int n = oC[i][j]; // where are we going
	int ind = (iC[n][0] == i); // index of incoming edge + 1
	int m = iC[n][ind]; // the other incoming point
 	if (m == -1)
 		return;
 	int ond = (oC[m][0] == n); // index of outgoing edge + 1
	if (oCh[m] == -1)
		return;
	UnChangeChoice(m,ond);
	return;	
}

void ChangeChoice(int i, int j) {
	oCh[i] = j;
	int n = oC[i][j];
	int ind = (iC[n][0] == i);
	int m = iC[n][ind];
	if (m == -1)
		return;
	int ond = (oC[m][0] == n);
	if (oCh[m] == ond)
		return;
	ChangeChoice(m,ond);
	return;	
}

void TryAllChoices(int i) {
	//cerr << "TryAllChoices(" << i << ")\n";
	if (i == N) {
		TrySolution();
		return;
	}
	if (oCh[i] == -1) {
		ChangeChoice(i,0);
		TryAllChoices(i+1);
		UnChangeChoice(i,0);
		ChangeChoice(i,1);
		TryAllChoices(i+1);
		UnChangeChoice(i,1);
	} else {
		TryAllChoices(i+1);
	}
}

void doit() {
	cin >> N >> M;
	for (int i = 0; i < N; i++) {
		oC[i][0] = -1;
		iC[i][0] = -1;
		oCh[i] = -1;
	}
	for (int i = 0; i < M; i++) {
		cin >> a >> b >> d;
		if (oC[a][0] == -1) {
			oC[a][0] = b;
			oC[a][1] = -1;
			oCh[a] = 0;
		} else {
			oC[a][1] = b;
			oCh[a] = -1;	
		}
		if (iC[b][0] == -1) {
			iC[b][0] = a;
			iC[b][1] = -1;
		} else
			iC[b][1] = a;
		di[a][b] = d;
	}
	mindist = 123456789;
	TryAllChoices(0);
	cout << mindist << '\n';
}

int main () {
	int T;
	cin >> T;
	for (int t = 1; t <= T; t++) {
		doit();
	}
	return 0;
}
