#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <climits>
#include <cassert>

#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>
#include <string>

#include <iostream>
#include <sstream>

#include <utility>
#include <functional>
#include <limits>
#include <numeric>
#include <algorithm> 

using namespace std;

int dL, dW;
double X, Y, Ws;

struct vect { double x, y; vect (double _x, double _y) : x(_x), y(_y) { } };

struct punt {
	double x, y; string naam;
	punt (double _x, double _y, string _n) : x(_x), y(_y), naam(_n) { }
	punt () { x = 0.0; y = 0.0; naam = "niets"; }
};

vect operator- (punt p, punt q) { return vect (q.x-p.x, q.y-p.y); }

double cross(vect u, vect v) { return u.x*v.y - u.y*v.x; }

int sgn(double i) { return (i > 0) ? 1 : ((i < 0) ? -1 : 0); }

int direction (punt a, punt b, punt c) { return sgn (cross(b-a,c-a)); }

punt P[123456];
punt LB, LO, RB, RO;
int aP;
//int pM[100];

long long fwa[123456];
void inca(int i, int delta) {
	while (i < 123456) { fwa[i] += delta; i |= i+1; }
}
int suma(int k) {
	int ret = 0;
	while (k > 0) { ret += fwa[k-1]; k &= k-1; }
	return ret;
}

long long fwb[123456];
void incb(int i, int delta) {
	while (i < 123456) { fwb[i] += delta; i |= i+1; }
}
int sumb(int k) {
	int ret = 0;
	while (k > 0) { ret += fwb[k-1]; k &= k-1; }
	return ret;
}

void addpcw(int L, int R, long long val) {
	inca(L, val);
	inca(R, -val);
	incb(L, -val*L);
	incb(R, val*R);
	//cerr << "Increased interval " << L << " " << R << " by " << val << "\n";
}

long long eval(int L, int R) {
	long long ret = suma(R)*R + sumb(R) - suma(L)*L - sumb(L);
	//cerr << "Evaluation between " << L << " and " << R << ": " << ret << "\n";
	return ret;
}

int memfindleft[123456];

int findleftend(int i) {
	if (memfindleft[i] != -1)
		return memfindleft[i];
	int lo = i;
	int hi = i+aP;
	punt H;
	if (P[i % aP].naam == "O") {
		if (P[i % aP].x > LO.x)
			H = LO;
		else
			H = LB;
	}
	if (P[i % aP].naam == "R") {
		if (P[i % aP].y > RO.y)
			H = RO;
		else
			H = LO;
	}
	if (P[i % aP].naam == "B") {
		if (P[i % aP].x < RB.x)
			H = RB;
		else
			H = RO;
	}
	if (P[i % aP].naam == "L") {
		if (P[i % aP].y < LB.y)
			H = LB;
		else
			H = RB;
	}
	while (hi - lo > 1) {
		int mid = (lo+hi)/2;
		//cerr << mid << " " << direction(P[i],H,P[mid % aP]) << "\n";
		((direction(P[i % aP],H,P[mid % aP]) < 0)  ? lo : hi) = mid;
	}
	memfindleft[i] = lo+1;
	return lo+1;
}

int memfindright[123456];

int findrightend(int i) {
	if (memfindright[i] != -1)
		return memfindright[i];
	int lo = i;
	int hi = i+aP;
	punt H;
	if (P[i % aP].naam == "O") {
		if (P[i % aP].x < RO.x)
			H = RO;
		else
			H = RB;
	}
	if (P[i % aP].naam == "R") {
		if (P[i % aP].y < RB.y)
			H = RB;
		else
			H = LB;
	}
	if (P[i % aP].naam == "B") {
		if (P[i % aP].x > LB.x)
			H = LB;
		else
			H = LO;
	}
	if (P[i % aP].naam == "L") {
		if (P[i % aP].y > LO.y)
			H = LO;
		else
			H = RO;
	}
	while (hi - lo > 1) {
		int mid = (lo+hi)/2;
		//cerr << mid << " " << direction(P[i],H,P[mid % aP]) << "\n";
		((direction(P[i % aP],H,P[mid % aP]) < 0)  ? lo : hi) = mid;
	}
	memfindright[i] = lo+1;
	return lo+1;
}

void pointadd(int i, long long val) {
	addpcw(i+1, findrightend(i), val);
	addpcw(findleftend(i), i+aP, val);
	//cerr << "Added point " << i << ": " << val << "\n";
	//pM[i] += val;
	return;
}

void doit() {
	long long sol = 0;
	//for (int i = 0; i < 100; i++)
	//	pM[i] = 0;
	aP = 0;
	cin >> dL >> dW >> X >> Y >> Ws;
	LO = punt(X,Y,"doos");
	LB = punt(X,Y+Ws,"doos");
	RO = punt(X+Ws,Y,"doos");
	RB = punt(X+Ws,Y+Ws,"doos");
	for (int i = 0; i < 123456; i++) {
		fwa[i] = 0;
		fwb[i] = 0;
		memfindleft[i] = -1;
		memfindright[i] = -1;
	}
	//cerr << "Doos: (" << X << "," << Y << ") tot (" << X+Ws << "," << Y+Ws << ")\n"; 
	for (int i = 0; i <= dL; i++) {
		P[aP] = punt(i,0,"O"); aP++; }
	for (int j = 1; j < dW; j++) {
		P[aP] = punt(dL,j,"R"); aP++; }
	for (int i = dL; i >= 0; i--) {		
		P[aP] = punt(i,dW,"B"); aP++; }
	for (int j = dW-1; j > 0; j--) {
		P[aP] = punt(0,j,"L"); aP++; }

	int LowB = 0;
	int UpB = 0; 
	for (int i = 0; i < aP; i++)
		pointadd(i,1);
	for (int i = 0; i < aP; i++) {
		int L = findrightend(i);
		int R = findleftend(i);
		//cerr << "i = " << i << " L = " << L << " R = " << R << " ";
		//cerr << P[i].x << "," << P[i].y << "\n";
		pointadd(i,-1);
		while (UpB < R) {
			pointadd(UpB,-1);
			UpB++;
		}
		while (LowB < L) {
			pointadd(LowB,1);
			LowB++;
		}
		//for (int j = i+1; j < L; j++)
		//	cerr << "Value at " << j << ": " << eval(j,j+1) << "\n";
		//for (int j = R; j < i+aP; j++)
		//	cerr << "Value at " << j << ": " << eval(j,j+1) << "\n";
		//cerr << "[";
		//for (int j = 0; j < 2*aP; j++) {
		//	cerr << pM[j];
		//	if (pM[j] > 0) {
		//		cerr << " (" << findrightend(j) << "-" << findleftend(j) << ")";
		//	}	
		//	cerr << ", ";
		//}
		//cerr << pM[2*aP] << "]\n";
		sol += eval(i+1,L) + eval(R,i+aP);
		pointadd(i+aP,1);
	}
	//cerr << sol << "\n";
	sol /= 3;
	sol -= 2*((dL+1)*dL*(dL-1))/6;
	sol -= 2*((dW+1)*dW*(dW-1))/6;
	cout << sol << "\n";
}

int main () {
	int T;
	cin >> T;
	for (int t = 1; t <= T; t++) {
		doit();
	}
	return 0;
}
