/*
Greedy mapcolouring solution by Stijn Duijzer.

Ideally (if we don't want greedy) we should get wrong answer 19 out of 20 times.
I don't think that is possible. Use the non_fast version for statistics.

Note: this fast version only works for N <= 32, becaus of bit messing (use 64 bit ints for N <= 64)

// @EXPECTED_RESULTS@: CORRECT

Running time: O(N * C * num_tries)
Memory usage: O(N + C)
*/

#include <iostream>
#include <algorithm>
using namespace std;

const int N = 16; // number of nodes
const int C = 4; // number of colors to test for
const int num_tries = 100000; // number of tries

int a[N]; // graph
int c[C]; // nodes per color
int o[N]; // for random order

int main()
{
  int runs, run, i, j, ans, best_ans, n, m, try_i, t, v;

  cin >> runs;
  for(run = 1; run <= runs; run++)
  {
    cin >> n >> m;

    // reset graph
    for(i = 0; i<n; i++) {a[i] = 0; o[i] = i;}

    // read graph
    for(t = 0; t<m; t++)
    {
      cin >> i >> j;
      a[i] |= (1 << j);
      a[j] |= (1 << i);
    }

    best_ans = C+1;   

    // try random order greedy
    for(try_i = 1; try_i <= num_tries; try_i++)
    {
      random_shuffle(o,o+n);
      for(i = 0; i<C; i++) c[i] = 0;
      ans = 1;
  
      for(t = 0; t<n; t++) 
      {
        v = o[t];

        // find first color neighbors don't have
        for(i = 0; i<C; i++) if( !(c[i]&a[v]) )
            {c[i] += (1<<v); ans = max(ans,i+1); break;}        

        if ( i == C ) {ans = C+1; break; }
        if ( ans >= best_ans ) break;
      }
    
      best_ans = min(best_ans,ans);
    }

    if ( best_ans == C+1 ) cout << "many" << endl;
    else cout << best_ans << endl;
  }

  return 0;
}






















