import java.util.*;


class alex_loops_over_edges_TLE
{
	private static Scanner input = new Scanner(System.in);

	private static Node[] nodes;
	private static Edge[] edges;
	public static void main(String[] args)
	{
		int T = input.nextInt();
		while (T > 0)
		{
			T--;
			new alex_loops_over_edges_TLE().solve();
		}
	}
	private void solve()
	{
		int N = input.nextInt();
		int M = input.nextInt();
		nodes = new Node[N];
		
		for (int i = 0; i < N; i++)
		{
			nodes[i] = new Node();
		}
		
		edges = new Edge[M];
		
		for (int i = 0; i < M; i++)
		{
			int I = input.nextInt();
			int J = input.nextInt();
			int D = input.nextInt();
			edges[i] = new Edge(nodes[I], nodes[J], D);
			nodes[J].addIn(edges[i]);
			nodes[I].addOut(edges[i]);
		}
		
		System.out.println(recur(0));
	}
	
	private static int isTour()
	{
		for (Node n : nodes)
		{
			if (!n.in1.Taken && !(n.in2 != null && n.in2.Taken)) return -1;
			if (!n.out1.Taken && !(n.out2 != null && n.out2.Taken)) return -1;
		}
		
		for (Node n : nodes) n.Seen = false;
		for (Edge e : edges)
		{
			if (e.Taken)
			{
				Edge next = e;
				next.From.Seen = true;
				while (!next.To.Seen)
				{
					next = next.To.out1.Taken ? next.To.out1 : next.To.out2;
					next.From.Seen = true;
				}
				
				break;
			}
		}
		for (Node n : nodes) if (!n.Seen) return -1;
		
		int length = 0;
		for (Edge e : edges)
		{
			if (e.Taken)
			{
				length += e.Distance;
			}
		}
		return length;
	}
	
	private static int recur(int current)
	{
		if (current == edges.length)
		{
			return isTour();
		}
		else
		{
			Edge e = edges[current];
			if (!e.Forbidden && !e.Taken)
			{
				e.take();
				int taken = recur(current + 1);
				e.remove();
				int notTaken = recur(current + 1);
				if (taken == -1) return notTaken;
				if (notTaken == -1) return taken;
				return taken > notTaken ? notTaken : taken;
			}
			else
			{
				return recur(current + 1);
			}
		}
	}
	
	private class Node
	{
		public Node()
		{
		}
		public boolean Seen;
		public Edge in1;
		public Edge in2;
		public Edge out1;
		public Edge out2;
		public void addIn(Edge newIn)
		{
			if (in1 == null)
			{
				in1 = newIn;
			}
			else
			{
				in2 = newIn;
			}
		}
		public void addOut(Edge newOut)
		{
			if (out1 == null)
			{
				out1 = newOut;
			}
			else
			{
				out2 = newOut;
			}
		}
		public Edge getOtherIn(Edge in)
		{
			if (in1 == in)
			{
				return in2;
			}
			else
			{
				return in1;
			}
		}
		public Edge getOtherOut(Edge out)
		{
			if (out1 == out)
			{
				return out2;
			}
			else
			{
				return out1;
			}
		}
	}
	
	private class Edge
	{
		public Node From;
		public Node To;
		public int Distance;
		public boolean Taken;
		public boolean Forbidden;
		public Edge(Node from, Node to, int distance)
		{
			From = from;
			To = to;
			Distance = distance;
		}
		public void take()
		{
			Taken = true;
			Edge otherIn = To.getOtherIn(this);
			if (otherIn != null)
			{
				otherIn.forbid();
			}
			Edge otherout = From.getOtherOut(this);
			if (otherout != null)
			{
				otherout.forbid();
			}
		}
		public void forbid()
		{
			if (!Forbidden)
			{
				Forbidden = true;
				Edge otherIn = To.getOtherIn(this);
				if (otherIn != null)
				{
					otherIn.take();
				}
				Edge otherout = From.getOtherOut(this);
				if (otherout != null)
				{
					otherout.take();
				}
			}
		}
		public void remove()
		{
			Taken = false;
			Edge otherIn = To.getOtherIn(this);
			if (otherIn != null)
			{
				otherIn.allow();
			}
			Edge otherout = From.getOtherOut(this);
			if (otherout != null)
			{
				otherout.allow();
			}
		}
		public void allow()
		{
			if (Forbidden)
			{
				Forbidden = false;
				Edge otherIn = To.getOtherIn(this);
				if (otherIn != null)
				{
					otherIn.remove();
				}
				Edge otherout = From.getOtherOut(this);
				if (otherout != null)
				{
					otherout.remove();
				}
			}
		}
	}
};
