#include <iostream>
#include <vector>
#include <set>
#include <cstdlib>
#include <utility>
#include <cmath>
#include <map>
#include <list>
#include <algorithm>
#include <cstring>
#include <queue>

using namespace std;

int main()
{
	int numEntries = 0;
	cin >> numEntries;
	cin.ignore();
	
	while (numEntries--)
	{
		int F, E;
		cin >> F >> E;
		vector<pair<int, int>> elevators(E);
		for (int i = 0; i < E; i++) {
			int R, M;
			cin >> R >> M;
			elevators[i].first = R;
			elevators[i].second = M;
		}
		vector<pair<int, bool>> visited(F, make_pair(0, false));
		visited[0].second = true;
		priority_queue<pair<int, int>> todo;
		todo.push(make_pair(0, 0));
		while (!todo.empty()) {
			auto current = todo.top();
			int currentNode = current.second;
			int currentDistance = current.first;
			todo.pop();

			if (currentDistance > visited[currentNode].first) {
				continue;
			}

			for (const auto& elevator : elevators) {
				if (currentNode % elevator.second == elevator.first) {
					for (int floorNo = elevator.first; floorNo < F; floorNo += elevator.second) {
						if (!visited[floorNo].second || visited[floorNo].first > currentDistance) {
							visited[floorNo].second = true;
							visited[floorNo].first = currentDistance;
							todo.push(make_pair(currentDistance, floorNo));
						}
					}
				}
			}

			if (currentNode > 0 && (!visited[currentNode - 1].second || visited[currentNode - 1].first > currentDistance + 1)) {
				todo.push(make_pair(currentDistance + 1, currentNode - 1));
				visited[currentNode - 1].first = currentDistance + 1;
				visited[currentNode - 1].second = true;
			}

			if (currentNode < F - 1 && (!visited[currentNode + 1].second || visited[currentNode + 1].first > currentDistance + 1)) {
				todo.push(make_pair(currentDistance + 1, currentNode + 1));
				visited[currentNode + 1].first = currentDistance + 1;
				visited[currentNode + 1].second = true;
			}
		}

		auto worstCase = max_element(visited.begin(), visited.end());
		cout << worstCase->first << " " << distance(visited.begin(), worstCase) << endl;
	}
	return 0;
}
