// Too slow solution to problem `Physical Music'
// Order: N^2 for instances of the form: 10  10 2 1 4 3 6 5 8 7 9
//
// Rudy van Vliet, 11 October, 2015

#include<iostream>
#include<cstring>

using namespace std;

const int MaxN = 1000000;
int posInDTN[MaxN+1];  // posInDTN[i]: position in Download Top N of single
                       //   ranked i in Single Top N
int posInSTN[MaxN+1];  // posInDTN[p]: position in Single Top N of single
                       //   ranked p in Download Top N
bool physical[MaxN+1]; // physical[p]: is single p in Download Top N
                       //   certainly available as CD single

//*************************************************************************

bool IntegerInRange (const char *variable, int val, int minVal, int maxVal)
{
  if (val>=minVal && val<=maxVal)
    return true;
  else
  { cout << variable << "=" << val << ", but should be in [" << minVal
         << "," << maxVal << "]" << endl;
    return false;
  }

}  // IntegerInRange

//*************************************************************************

int main ()
{ int nInst, inst;
  int N,
      i,        // position in Single Top N
      p, q,     // position in Download Top N
      nrPhysical;  // number of singles that are certainly available
                   // as CD single
  bool OK,       // input OK
       found;    // we found a single that was overtaken by p

  cin >> nInst;
  for (inst=1;inst<=nInst;inst++)
  {
    cin >> N;

    for (p=1;p<=N;p++)   // for verifying input
      posInSTN[p] = 0;

    for (i=1;i<=N;i++)
    { cin >> p;

      if (IntegerInRange ("p", p, 1, N))
      {
        posInDTN[i] = p;
        posInSTN[p] = i;
      }
    }

    OK = true;   // verify input
    for (p=1;p<=N;p++)
      OK = OK && IntegerInRange ("posInSTN", posInSTN[p], 1, N);
 
    if (OK)
    {
      nrPhysical = 0;

      for (i=1;i<=N;i++)
      { p = posInDTN[i];

        if (p>i)
          // p is on higher position i in Single Top N than in Download Top N;
          // hence, p must have overtaken one or more other singles
        { physical [p] = true;
          nrPhysical ++;
        }
        else
        {   // check all singles q higher than p in Download Top N, to see
            // if it has been overtaken by p
          found = false;
          q = 1;
          while (!found && q<p)
          { if (posInSTN[q]>i)
              found = true;
            else
              q++;
          }

          if (found)
          { physical [p] = true;
            nrPhysical ++;
          }
          else
            physical [p] = false;
        }

      }  // for i

      cout << nrPhysical << endl;
      for (p=1;p<=N;p++)
        if (physical[p])
          cout << p << endl;

    }  // input OK

  }  // for inst

  return 0;

}
