#include <iostream>
#include <vector>
#include <set>
#include <cstdlib>
#include <utility>
#include <cmath>
#include <map>
#include <list>
#include <algorithm>
#include <cstring>
#include <set>
#include <limits>

using namespace std;

bool visited[36];

int shortestPath(const vector<vector<pair<int, int>>>& edges, const int start = 0, const int pathNodes = 0, const int pathLength = 0)
{
	if (pathNodes == (int) edges.size() && start == 0) {
		return pathLength;
	}

	int shortest = numeric_limits<int>::max();
	if (visited[start] == true) {
		return shortest;
	}
	visited[start] = true;
	for (auto& neighbour : edges[start]) {
		shortest = min(shortest, shortestPath(edges, neighbour.first, pathNodes + 1, pathLength + neighbour.second));
	}
	visited[start] = false;

	return shortest;
}

int main()
{
	int numEntries = 0;
	cin >> numEntries;
	cin.ignore();
	
	while (numEntries--)
	{
		int N, M;
		cin >> N >> M;
		vector<vector<pair<int, int>>> edges(N);
		for (int i = 0; i < M; i++)
		{
			int source, target, distance;
			cin >> source >> target >> distance;
			edges[source].push_back(make_pair(target, distance));
		}

		memset(visited, false, sizeof(visited));
		cout << shortestPath(edges) << endl;
	}
	return 0;
}
