#include <cmath>
#include <iostream>

using namespace std;

int greatestcommondivisor (int A, int B)
{
  int c;
  while (A != 0)
  {
     c = A; A = B % A;  B = c;
  }
  return B;
}

void extended_euclidean(int A, int B, int* gcd, int* R, int* S)
{
	// Assume A > B
	int first = A;
	int second = B;
	int first_times_A = 1;
	int first_times_B = 0;
	int second_times_A = 0;
	int second_times_B = 1;
	
	while ((first % second) != 0)
	{
		int times = first / second;
		int new_second = first - second * times;
		int new_second_times_A = first_times_A - times * second_times_A;
		int new_second_times_B = first_times_B - times * second_times_B;
		first = second;
		first_times_A = second_times_A;
		first_times_B = second_times_B;
		second = new_second;
		second_times_A = new_second_times_A;
		second_times_B = new_second_times_B;
	}
	*gcd = second;
	*R = second_times_A;
	*S = second_times_B;
}

int main(int argc, char** argv)
{
	int T;
	cin >> T;
	while (T > 0)
	{
		T--;
		int R, S, Q;
		
		cin >> R >> S >> Q;
		
		int gcd;
		int A_prime;
		int B_prime;
		extended_euclidean(R, -S, &gcd, &A_prime, &B_prime);

		B_prime = -B_prime;

		int A = A_prime * Q / gcd;
		int B = B_prime * Q / gcd;
			
		cout << A << " " << B << endl;
	}
		
	return 0;
}
