/*
Greedy (thus incorrect) mapcolouring solution by Stijn Duijzer.
Ideally (if we don't want greedy) we should get wrong answer 19 out of 20 times.
I don't know whether that is possible.

Note: this version also outputs statistics. fast version does not

// @EXPECTED_RESULTS@: WRONG_ANSWER

Running time: O(N^2 * num_tries) = O(N^2 * 1000)
Memory usage: O(N+M)
*/

#include <iostream>
#include <algorithm>
using namespace std;

const int N = 16;
const int M = 120;

const int num_tries = 1000;

bool G[N][N]; // graph
int C[N]; // colors per node
int order[N]; // for random order
int counter[6]; // for statistics

int main()
{
  int runs; cin >> runs;
  for(int run = 1; run <= runs; run++)
  {
    int n, m; cin >> n >> m;

    // reset graph
    for(int i = 0; i < n; i++)
      for(int j = 0; j < n; j++)
        G[i][j] = false;
    for(int i = 0; i < n; i++) order[i] = i;

    // read graph
    for(int e = 0; e < m; e++)
    {
      int i, j; cin >> i >> j;
      G[i][j] = G[j][i] = true;
    }

    int best_ans = 5;   
    for(int i = 0; i <= 5; i++) counter[i] = 0;

    // try random order greedy
    for(int try_i = 1; try_i <= num_tries; try_i++)
    {
      random_shuffle(order,order+n);
      for(int v = 0; v < n; v++) C[v] = 0;
      int ans = 1;
  
      for(int t = 0; t < n; t++) 
      {
        int v = order[t];
        int pc = 0; // find neighbor colours
        for(int i = 0; i < n; i++) if ( G[v][i] ) pc = pc | C[i];
  
        if ( !(pc & 1) ) {C[v] = 1;}
        else if ( !(pc & 2) ) {C[v] = 2; ans = max(ans,2);}
        else if ( !(pc & 4) ) {C[v] = 4; ans = max(ans,3);}
        else if ( !(pc & 8) ) {C[v] = 8; ans = 4;}
        else {ans = 5; break; }
      }
    
      if ( ans < best_ans ) best_ans = ans;
      counter[ans]++;
    }

    cout << "case: " << run << " --> ";
    if ( best_ans == 5 ) cout << "many" << endl;
    else cout << best_ans << endl;
    

    for(int i = 1; i <= 5; i++)
    {
      cout << "  " << i << ": " << counter[i] << endl;
    }
  }

  return 0;
}






















